#include <iostream>
#include <unistd.h>
using namespace std;


/**
 * @brief 
 * Temos duas Classes: container e deque.
 * A Classe container que é utilizada para guardar o conteúdo do nó e o próximo nó de um encadeamento.
 * 
 * A classe Deque possui dois ponteiros: Inicio e Fim. Onde apontam para o início e o fim respectivamente de uma lista encadeada.
 * Ao inserir um novo elemento no início, o novo elemento aponta seu proximo como o *inicio e o início aponta para este novo elemento.
 * 
 * 
 * Ao inserir um elemento no fim, é criado um nó. o próximo elemento do fim aponta para ele, e após o fim aponta para este nó.
 * 
 * Ao remover no início ele verifica se há elementos na lista, se houver ele aponta o início para o próximo
 * 
 * Ao remover no Fim, ele percorre toda a lista, mas armazena a penultima, e aponta o fim para este penultimo nó.
 */


template <class D> class container {
    public:
        container *proximo;
        D elemento;
};


template <class T, class Container=container<T>>
class deque {
    public:
        void insereInicio(T elem) {
            auto cont = new container<T>();
            cont->elemento = elem;

            if (inicio == nullptr) {    
                fim = cont;           
                cont->proximo = nullptr;
            }
            else 
                cont->proximo = inicio;

            inicio = cont;
        }


        void insereFim(T elem) {
            auto cont = new container<T>();
            cont->elemento = elem;
            cont->proximo = nullptr;

            if (fim == nullptr)
                inicio = cont;
            else 
                fim->proximo = cont;
            
            fim = cont;


        }

        T removeinicio() {
            if (inicio != nullptr) {
                T elemento = inicio->elemento;
                Container *i = inicio;
                if (inicio == fim) { 
                    inicio = nullptr;
                    fim = nullptr;
                }
                else
                    inicio = inicio->proximo;
                delete i;
                return elemento;
            }
            else
                return -1;
        }
        T removeFim() {
            if (fim != nullptr) {
                T elemento = fim->elemento;
                if (inicio == fim) {
                    inicio = nullptr;
                    delete fim;
                    fim = nullptr;
                }
                else {
                    Container *f = fim;
                    Container *novoFim = inicio;
                    while (novoFim->proximo != fim){
                        novoFim = novoFim->proximo;
                    }
                    fim = novoFim;
                    delete f;
                }
                return elemento;
            }
            else
                return -1;
        }
        T bucaInicio() {
            
            return inicio->elemento;
        }
        T buscaFim() {
            return fim->elemento;
        }
    private:
        Container *inicio = nullptr;
        Container *fim = nullptr;

};


int main(int argc, char* argv[]) {

    deque<int> meuDeque;

    meuDeque.insereInicio(9);
    meuDeque.insereInicio(3);
    meuDeque.insereInicio(4);
    meuDeque.insereInicio(7);

    auto d = meuDeque.removeFim();

    while (d != -1) {
        printf ("%d  ", d);
        d = meuDeque.removeinicio();

    }
    return 0;

}