#include <iostream>
#include <unistd.h>
using namespace std;


template <class T>
class Pilha { 

    public:
        void empilha(T elemento) {
            N++;
            elementos[N -1] = elemento;

        }
        T desempilha() {
            if (N > 0) {
                N--;
                return elementos[N];
            }
            else
                return -1;
        }

        T topo() {
            if (N > 0)
                return elementos[N -1];
            else   
                return -1;
        }
    private:
        static const int MAX = 900;
        int N = 0;
        T elementos[MAX];

};

/**
 * @brief Reescreva uma fila utilizando duas pilhas
 * Descrição Abaixo
 * 
 * @tparam T 
 */
template <class T>
class Fila {
    public:

        /**
         * @brief Para enfileirar, apenas utilizamos a função de empilhar
         * 
         * @param elem 
         */
        void enfilera(T elem) {
            pilha->empilha(elem);
            
        }

        /**
         * @brief Para desenfilerar, 
         *      passo os elementos de uma pilha para outra, exeto o ultimo elemento
         *      guardo esse ultimo elemento para o retorno.
         *      Volto todos os elementos da pilha auxiliar para a pilha principal.
         * @return T 
         */
        T desenfilera() {
            
            if (pilha->topo() == -1)
                return -1;
            auto paux = new Pilha<T>();
            T elemento;
            while (pilha->topo() != -1) {
                elemento = pilha->desempilha();
                if (pilha->topo() != -1)
                    paux->empilha(elemento);
            }

            while (paux-> topo() != -1) {
                pilha->empilha(paux->desempilha());
            }
            delete paux;
            return elemento;
        }

        T frente() {
            pilha->topo();
        }
        
    private:

        Pilha<T> *pilha = new Pilha<T>();

};


int main(int argc, char* argv[]) {

    Fila<int> fila;
    fila.enfilera(2);
    fila.enfilera(32);
    fila.enfilera(54);
    fila.enfilera(96);
    fila.enfilera(11);
    fila.enfilera(78);

    int e = fila.desenfilera();
    while (e != -1) {
        cout << "----------------  elemento desinfilerado: " << e << "------------" << endl;
        e = fila.desenfilera();
    }

    return 0;

}