#include <iostream>


template <class D> class container {
    public:
        container *proximo;
        D elemento;
};


template <class T, class Container=container<T>>
class Fila {
    public:
        void enfilera(T elem) {
            auto cont = new container<T>();
            cont->elemento = elem;

            if (fim != nullptr)
                fim->proximo = cont;
                
            else 
                inicio = cont;
            
            fim = cont;
        }


        T desenfilera() {
            if (inicio != nullptr) {
                T elemento = inicio->elemento;
                Container *i = inicio;
                inicio = inicio->proximo;
                if (inicio == nullptr)
                    fim = nullptr;
                delete i;
                return elemento;
            }
            else
                return -1;
        }

        T frente() {
            if (inicio != nullptr)
                return inicio->elemento;
            else
                return -1;
        }
        
    private:
        Container *inicio = nullptr;
        Container *fim = nullptr;

};

template <class T>
class Pilha { 

    public:
        void empilha(T elemento) {
            N++;
            elementos[N -1] = elemento;

        }
        T desempilha() {
            if (N > 0) {
                N--;
                return elementos[N];
            }
            else
                return -1;
        }

        T topo() {
            if (N > 0)
                return elementos[N -1];
            else   
                return -1;
        }

        int tamanho() {
            return N;
        }
    private:
        static const int MAX = 900;
        int N = 0;
        T elementos[MAX];

};


/**
 * Dado uma pilha, inverter ela utilizando uma pilha auxiliar
 * 
 * para isso eu percorro toda a pilha
 * 1° passo: Guardo o topo da pilha numa aux
 * 2° passo: Desempilha o primeiro ítem da pilha
 * 3° passo: Passo (todos os itens que ainda não foram trocados) da pilha para a pilha auxiliar
 * 4° passo: Empilho o item salvo no aux para ficar como base da pilha.
 *           dessa forma, o que eu fiz foi inverter o elemento que estava
 *           no topo, indo para o começo.
 * 5° passo: volto (todos os ítens que ainda não foram trocados) da pilhaAux para a pilha
 * 6° passo: repito os passos até finalizar a troca
 * 
 * 
 */
template <class T> void inverterPilha(Pilha<T> *pilha) {

    Pilha<T> pilhaAux;
    int n = pilha->tamanho();
    T aux;
    for (int i = 0; i < n; i++) {
        aux = pilha->topo();
        pilha->desempilha();
        for (int j=0; j < n - i -1 ; j++) {
            
            pilhaAux.empilha(pilha->desempilha());
        }
        pilha->empilha(aux);
        for (int j=0; j < n - i -1 ; j++) {
            pilha->empilha(pilhaAux.desempilha());
        }
    }

}

/**
 * @brief Dada uma pilha, inverter os valores utilizando uma fila
 *          1° passo: percorrer toda a pilha, desempilhando e enfileirando numa fila
 *          2° passo: desinfilerar toda a fila, empilhando na pilha
 * 
 * @tparam T 
 * @param pilha 
 */

template <class T> void inverterPilhaComFila(Pilha<T> *pilha) {

    Fila<T> filaAux;
    while (pilha->topo() != -1) {
        filaAux.enfilera(pilha->desempilha());
    }

    while (filaAux.frente() != -1) {
        pilha->empilha(filaAux.desenfilera());
    }

}

/**
 * @brief dado uma pilha, inverta utilizando duas pilhas
 * 
 *  1° Passo: passo todos os itens para uma pilha auxiliar
 *  2° Passo: passo todos os iten para uma segunda pilha auxiliar
 *  3° Passo: volto todos os itens para a primeira pilha
 * 
 *  Dessa forma a pilha ficará invertida
 * 
 * @tparam T 
 * @param pilha 
 */
template <class T> void inverterPilhaComDuasPilhas(Pilha<T> *pilha) {

    Pilha<T> pilhaAux, pilhaAux2;
    while (pilha->topo() != -1) {
        pilhaAux.empilha(pilha->desempilha());
    }
    while (pilhaAux.topo() != -1) {
        pilhaAux2.empilha(pilhaAux.desempilha());
    }
    while (pilhaAux2.topo() != -1) {
        pilha->empilha(pilhaAux2.desempilha());
    }
}

void preencherPilha(Pilha<char> &pilha) {

    pilha.empilha('a');
    pilha.empilha('b');
    pilha.empilha('c');
    pilha.empilha('d');
    pilha.empilha('e');
    pilha.empilha('f');
    pilha.empilha('g');
    pilha.empilha('h');
    pilha.empilha('i');
    pilha.empilha('j');
    pilha.empilha('k');
    pilha.empilha('l');
    pilha.empilha('m');
    pilha.empilha('n');
    pilha.empilha('o');
    pilha.empilha('p');
    pilha.empilha('q');
    pilha.empilha('r');
    pilha.empilha('s');
    pilha.empilha('t');
    pilha.empilha('u');
    pilha.empilha('v');
    pilha.empilha('w');
    pilha.empilha('x');
    pilha.empilha('y');
    pilha.empilha('z');
}

void printarPilha(Pilha<char> &pilha, std::string texto) {

    std::cout << "----" << texto << "------" << std::endl;
    while (pilha.topo() != -1) {
        std::cout << "| " << pilha.desempilha() << " " ;
    }
    std::cout << "|" << std::endl;
}

int main(int argc, char* argv[]) {

    Pilha<char> pilha;
    preencherPilha(pilha);
    printarPilha(pilha, "Pilha normal");

    

    preencherPilha(pilha);
    inverterPilha(&pilha);
    printarPilha(pilha, "Pilha invertida com pilha");

    preencherPilha(pilha);
    inverterPilhaComFila(&pilha);
    printarPilha(pilha, "Pilha invertida com FILA");

    preencherPilha(pilha);
    inverterPilhaComDuasPilhas(&pilha);
    printarPilha(pilha, "Pilha invertida com duas Pilhas");
    

    
    return 0;
}