#include <iostream>
#include <sstream>
#include <vector>
#include <algorithm>

using namespace std;

template <class D> class container {
    public:
        container *proximo;
        D elemento;
};


template <class T, class Container=container<T>>
class Fila {
    public:
        void enfilera(T elem) {
            auto cont = new container<T>();
            cont->elemento = elem;

            if (fim != nullptr)
                fim->proximo = cont;
                
            else 
                inicio = cont;
            
            fim = cont;
        }


        T desenfilera() {
            if (inicio != nullptr) {
                T elemento = inicio->elemento;
                Container *i = inicio;
                inicio = inicio->proximo;
                if (inicio == nullptr)
                    fim = nullptr;
                delete i;
                return elemento;
            }
            else
                return -1;
        }

        T frente() {
            if (inicio != nullptr)
                return inicio->elemento;
            else
                return -1;
        }
        
    private:
        Container *inicio = nullptr;
        Container *fim = nullptr;

};

template <class T>
class Pilha { 

    public:
        void empilha(T elemento) {
            N++;
            elementos[N -1] = elemento;

        }
        T desempilha() {
            if (N > 0) {
                N--;
                return elementos[N];
            }
            else
                return -1;
        }

        T topo() {
            if (N > 0)
                return elementos[N -1];
            else   
                return -1;
        }
    private:
        static const int MAX = 900;
        int N = 0;
        T elementos[MAX];

};

bool operador(char s) {
    vector<char> operadores = {'*','+', '-', '/' };
    for(char o: operadores) {
        if (o == s)
            return true;
    }

    return false;
}

string polonisar(string expr) {

    auto stream = stringstream{expr};
    char aux;
    Pilha<char> operadores;
    Fila<char> fila_retorno;
    while (stream >> aux) {
        
        if (aux != '(')
            if (operador(aux))
                operadores.empilha(aux);
            else
                if (aux == ')') {
                    while (operadores.topo() != -1){
                        fila_retorno.enfilera(operadores.desempilha());
                    }
                }
                else
                    fila_retorno.enfilera(aux);
    }
    string exp_retorno;

    while (fila_retorno.frente() != -1) {
        exp_retorno += fila_retorno.desenfilera();
    }
    

    return exp_retorno;
}


int main(int argc, char* argv[]) {

    string expr = "((A+B)*(C-(F/D)))";
    cout <<"Expressão: " << expr << endl;
    cout <<"Expressão Polonesa Reversa: " << polonisar(expr) << endl;
    
    return 0;
    
}